#include "../include/Encoder.h"

Encoder* Encoder::instance = nullptr;

Encoder* Encoder::getInstance() {
    return Encoder::instance;
}

Encoder::Encoder(int pinSW, int pinDT, int pinCLK) {
    this->pinSW = pinSW;
    this->pinDT = pinDT;
    this->pinCLK = pinCLK;

    pinMode(pinSW, INPUT);
    pinMode(pinDT, INPUT);
    pinMode(pinCLK, INPUT);

    attachInterrupt(digitalPinToInterrupt(this->pinCLK), Encoder::dtEvent, RISING);
    attachInterrupt(digitalPinToInterrupt(this->pinSW), Encoder::swEvent, RISING);

    this->number = 0;

    Encoder::instance = this;
}

IRAM_ATTR void Encoder::dtEvent() {
    Encoder* encoder = Encoder::getInstance();
    if(digitalRead(encoder->pinDT)){
        encoder->number++;
    } else {
        encoder->number--;
    }
    Serial.println(encoder->number);
    delay(10);
}

IRAM_ATTR void Encoder::swEvent() {
    Serial.print("test :");
    Serial.print(digitalRead(ENCODER_SWITCH));
    Serial.print(" ");
    Serial.print(digitalRead(ENCODER_DT));
    Serial.print(" ");
    Serial.println(digitalRead(ENCODER_CLK));
    delay(10);
}
